% Experimental data from literature - figure 1
% Salil Apte 
% 23.03.2017
clear all
clc
addpath(genpath('superbar-master'))

bws = -5:5:80; 

r1 = [228 26 28]./255; %TH
b1 = [55 126 184]./255; %OH
g1 = [77 175 74]./255;  %OPN
l1 = [152 78 163]./255; %OPP
o1 = [255 127 0]./255; %TPN
y1 = [255 255 51]./255; %TPP

Colour = [r1;b1;g1;l1];
Colour6 = [r1;b1;g1;l1;o1;y1];
%% Stride Length
%bws =  -5      0     5    10    15    20    25    30    35    40    45    50   55    60    65    70
%treadmill, healthy
SL1 = [  NaN, 1.358/1.358, 1.362/1.358, 1.366/1.358, 1.371/1.358,  1.376/1.358,   1.381/1.358,  1.386/1.358,  1.885/1.358,  1.3910/1.358, 1.3935/1.358,  1.396/1.358,  1.397/1.358, 1.398/1.358,  1.399/1.358,  1.400/1.358, NaN, NaN; %Threlkeld 2003
        NaN, 0.4335/0.4335, 0.4278/0.4335, 0.4221/0.4335, 0.4164/0.4335, 0.4107/0.4335,0.4052/0.4335,0.4037/0.4335, 0.4022/0.4335, 0.4007/0.4335, 0.3992/0.4335,	0.3976/0.4335, 0.4041/0.4335, 0.4106/0.4335, 0.4171/0.4335, 0.4236/0.4335,	0.4303/0.4335, NaN ; % Van Hedel 2006        
        NaN, 1.005/1.005, NaN, NaN, NaN,  0.972/1.005,   NaN,  NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN ; %Franz 2007        
        NaN, 1.301/1.301, 1.3030/1.301, 1.3050/1.301, 1.3070/1.301, 1.3091/1.301, 1.3061/1.301, 1.3031/1.301, 1.3001/1.301,1.297/1.301, NaN, NaN, NaN, NaN, NaN, NaN, NaN, NaN ; %Thomas 2007
        NaN, 1.217/1.217, NaN, NaN, NaN, 1.206/1.217, NaN, NaN, NaN,1.187/1.217, NaN, NaN, NaN, NaN, NaN, NaN, NaN, NaN ; % Lewek 2010
        NaN, 1, NaN, NaN, NaN, 0.9926, NaN, NaN, NaN,1.0128, NaN, NaN, NaN, 1.0054, NaN, NaN, NaN, NaN] ; % Dragunas 2016    

SL1L = SL1(:,2:17);
bws1 = repmat(bws(2:17),6,1);
SL1_lm = fitlm(bws1(:),SL1L(:));

SL1 = [fillmissing(SL1(1,:),'linear','Endvalues','none');
        fillmissing(SL1(2,:),'linear','Endvalues','none');
        fillmissing(SL1(3,:),'linear','Endvalues','none');
        fillmissing(SL1(4,:),'linear','Endvalues','none');
        fillmissing(SL1(5,:),'linear','Endvalues','none')
        fillmissing(SL1(6,:),'linear','Endvalues','none')];


%overground, healthy
SL2 = [ 1.39/1.27, 1.27/1.27, 1.23/1.27, 1.19/1.27, NaN,  1.32/1.27,   NaN,  1.28/1.27,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN ; %Patino 2007
        NaN, 0.962/0.962, NaN, 0.959/0.962, NaN,  0.915/0.962,   NaN,  0.8874/0.962,  NaN,  0.8750/0.962, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN ; % Burgess 2010 Healthy
        1.37/1.23, 1.21/1.21, NaN, NaN, 1.23/1.21,  NaN,   NaN,  1.23/1.21,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN ; %Fischer 2014
        NaN, 0.97/0.97, NaN, 0.98/0.97, NaN,  0.96/0.97,   NaN,  0.98/0.97,  NaN,  0.98/0.97, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN ]; %Mun 2016

SL2L = SL2(:,2:10);
bws2 = repmat(bws(2:10),4,1);
SL2_lm = fitlm(bws2(:),SL2L(:));

SL2 = [fillmissing(SL2(1,:),'linear','Endvalues','none');
        fillmissing(SL2(2,:),'linear','Endvalues','none');
        fillmissing(SL2(3,:),'linear','Endvalues','none');
        fillmissing(SL2(4,:),'linear','Endvalues','none')];
 
%overground, NI
SL3 = [1.26/1.16, 1.16/1.16, NaN, NaN, NaN,  NaN,   NaN,  1/1.16,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN ; %Sousa 2009 Impaired
        0.5/0.607, 0.607/0.607, NaN, 0.668/0.607, NaN,  0.636/0.607,   NaN,  0.597/0.607,  NaN,  0.568/0.607, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN] ; %Burgess 2010 PostStroke

SL3L = SL3(:,2:10);
bws3 = repmat(bws(2:10),2,1);
SL3_lm = fitlm(bws3(:),SL3L(:));

SL3 = [fillmissing(SL3(1,:),'linear','Endvalues','none');
        fillmissing(SL3(2,:),'linear','Endvalues','none')];


%treadmill, NI
SL4 = [ NaN, 1, NaN, NaN, 0.9344,  NaN,   NaN,  1,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN] ; %Hesse 1999 Paretic
SL4_lm = fitlm(bws(2:8),SL4(2:8));

SL4 = fillmissing(SL4(1,:),'linear','Endvalues','none');
    
SL1M = mean(SL1,'omitnan');
SL1S = std(SL1,'omitnan');
SL2M = mean(SL2,'omitnan');
SL2S = std(SL2,'omitnan');
SL3M = mean(SL3,'omitnan');
SL3S = std(SL3,'omitnan');
SL4S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;

SLM = [SL1M;SL2M;SL3M;SL4]';
SLS = [SL1S;SL2S;SL3S;SL4S]';

Colour = [r1;b1;g1;o1];

figure 
superbar(bws,SLM, 'E', SLS,'BarFaceColor', permute(Colour, [4 1 2 3]));
grid on
grid minor
axis([-10 80 0 1.5])
set(gca,'fontsize',36)
xticks([-10 0 10 20 30 40 50 60 70 80])
xticklabels({'No BWS', '0', '10', '20', '30', '40', '50', '60', '70', '80'})
ylabel('Stride Length','FontSize',36,'FontWeight','bold')
xlabel('Percentage Body weight unloading (BWU)','FontSize',36,'FontWeight','bold')
hold on
SL1M_est = (2.9135e-05).*bws(2:17) + 0.9979;
plot(bws(2:17),SL1M_est,'r--','linewidth',2) 
SL2M_est = (-5.2200e-04).*bws(2:10) + 0.9971;
plot(bws(2:10),SL2M_est,'b--','linewidth',2)
SL3M_est = -0.0026.*bws(2:10) +1.0391;
plot(bws(2:10),SL3M_est,'g--','linewidth',2)
SL4M_est = (4.7676e-18).*bws(2:8) +0.9781;
plot(bws(2:8),SL4M_est,'color',o1,'linestyle','--','linewidth',2)
%% Walking Speed
%bws = -5 0     5    10    15    20    25    30    35    40    45   50 55 60    65    70 -75 80

%treadmill, healthy
WS1 = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0,0] ; %Nil
%overground healthy
WS2 = [ 1.03/0.85, 0.85/0.85, NaN, 0.78/0.85, NaN,  0.81/0.85,   NaN,  0.77/0.85,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN,NaN ; %Patino 2007
        1.2/0.7,1, 0.7/0.7, NaN,  0.62/0.7,   NaN,  0.61/0.7,  NaN,  0.59/0.7, NaN,  NaN,  NaN, NaN,  NaN,  NaN , NaN,NaN, NaN; % Burgess 2010 Healthy
        1.29/1.09, 1.09/1.09, NaN, NaN, 1.12/1.09,  NaN,   NaN,  1.12/1.09,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN , NaN,NaN; %Fischer 2014
        NaN, 0.366/0.366, NaN, 1, NaN,  0.395/0.366,   NaN,  0.406/0.366,  NaN,  0.413/0.366, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN,NaN]; %Mun 2016

WS2L = WS2(:,2:10);
bws2 = repmat(bws(2:10),4,1);
WS2_lm = fitlm(bws2(:),WS2L(:));

WS2 = [fillmissing(WS2(1,:),'linear','Endvalues','none');
        fillmissing(WS2(2,:),'linear','Endvalues','none');
        fillmissing(WS2(3,:),'linear','Endvalues','none');
        fillmissing(WS2(4,:),'linear','Endvalues','none')];

%overground NI
WS3 = [ 0.41/0.38,0.38/0.38, NaN, NaN, NaN,  NaN,   NaN,  0.30/0.38,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN , NaN,NaN; %Sousa 2009 Impaired        
        NaN, 0.36/0.36, NaN, 0.39/0.36, NaN,  0.37/0.36,   NaN,  0.34/0.36,  NaN,  0.31/0.36, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN]; %Burgess 2010 PostStroke

WS3L = WS3(:,2:10);
bws3 = repmat(bws(2:10),2,1);
WS3_lm = fitlm(bws3(:),WS3L(:));    

WS3 = [fillmissing(WS3(1,:),'linear','Endvalues','none');
        fillmissing(WS3(2,:),'linear','Endvalues','none')];

%treadmill NI
WS4 = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0,0] ; %Nil    
    
WS1S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
WS2M = mean(WS2,'omitnan');
WS2S = std(WS2,'omitnan');
WS3M = mean(WS3,'omitnan');
WS3S = std(WS3,'omitnan');
WS4S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
WSM = [WS1;WS2M;WS3M;WS4]';
WSS = [WS1S;WS2S;WS3S;WS4S]';
    
figure 
superbar(bws,WSM, 'E', WSS,'BarFaceColor', permute(Colour, [4 1 2 3]));
grid on
grid minor
axis([-10 80 0 1.8])
xticks([-10 0 10 20 30 40 50 60 70 80])
xticklabels({'No BWS', '0', '10', '20', '30', '40', '50', '60', '70', '80'})
set(gca,'fontsize',36)
ylabel('Walking Speed','FontSize',36,'FontWeight','bold')
xlabel('Percentage Body weight unloading (BWU)','FontSize',36,'FontWeight','bold')
hold on
WS2M_est = 0.00015.*bws(2:10) + 0.9862;
plot(bws(2:10),WS2M_est,'b--','linewidth',2) 
WS3M_est = -0.0045.*bws(2:10) +1.0417;
plot(bws(2:10),WS3M_est,'g--','linewidth',2)
%% Cadence
%bws =  0     5    10    15    20    25    30    35    40    45    50   55    60    65    70
% Treadmill healthy
C1 = [ NaN, 1.852/1.852, 1.8425/1.852, 1.833/1.852, 1.8278/1.852,  1.8226/1.852,   1.8174/1.852,  1.812/1.852,  1.809/1.852,  1.806/1.852, 1.803/1.852,  1.8/1.852,  1.7987/1.852, 1.7974/1.852,  1.7961/1.852,  1.795/1.852,NaN,NaN; %Threlkeld 2003
     NaN, 0.5627/0.5627 , NaN, NaN, NaN, NaN, 0.6138/0.5627, NaN,  NaN,  NaN, NaN,  0.6303/0.5627 ,  NaN, NaN,  NaN,  NaN, 0.6167/0.5627 , NaN ; %Van Hedel 2006     
     NaN, 0.988/0.988, NaN, NaN, NaN, 0.9828/0.988, NaN,  NaN,  NaN,  0.912/0.988, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN ; %Thomas 2007
     NaN, 1.7167/1.7167,NaN,NaN,NaN,1.7717/1.7167, NaN, NaN, NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN ; %Franz 2007
     NaN, 1.1810/1.1810, NaN, NaN, NaN, NaN, NaN,  1.18352/1.1810,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN  ]; %Aaslund 2008

C1L = C1(:,2:17);
bws1 = repmat(bws(2:17),5,1);
C1_lm = fitlm(bws1(:),C1L(:));

C1 = [fillmissing(C1(1,:),'linear','Endvalues','none');
        fillmissing(C1(2,:),'linear','Endvalues','none');
        fillmissing(C1(3,:),'linear','Endvalues','none');
        fillmissing(C1(4,:),'linear','Endvalues','none');
        fillmissing(C1(5,:),'linear','Endvalues','none')];

%overground, healthy
C2 = [1.217/1.32, 1.32/1.32, 1.3/1.32, 1.28/1.32, 1.26/1.32,  1.24/1.32,   1.21/1.32,  1.18/1.32,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN ; %Patino 2007
    NaN, 1.368/1.368, 1.371/1.368, 1.374/1.368, 1.3725/1.368,  1.371/1.368,   1.365/1.368,  1.359/1.368,  1.3515/1.368,  1.344/1.368, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN ; % Burgess 2010 Healthy
     1.888/1.782, 1.782/1.782, 1.792/1.782, 1.802/1.782, 1.812/1.782,  1.8203/1.782,   1.8286/1.782,  1.837/1.782,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN ]; %Fischer 2014

C2L = C2(:,2:10);
bws2 = repmat(bws(2:10),3,1);
C2_lm = fitlm(bws2(:),C2L(:));

C2 = [fillmissing(C2(1,:),'linear','Endvalues','none');
        fillmissing(C2(2,:),'linear','Endvalues','none');
        fillmissing(C2(3,:),'linear','Endvalues','none')];

%overground, patients
C3 = [1.180, 1.183/1.183, NaN, NaN, NaN,  NaN,   NaN,  1.180/1.183,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN  ; %Sousa 2009 patients
      NaN, 1.136/1.136, 1.139/1.136, 1.142/1.136, 1.136/1.136,  1.130/1.136,   1.1145/1.136,  1.099/1.136,  1.077/1.136,  1.055/1.136, NaN,  NaN,  NaN, NaN,  NaN,  NaN,NaN, NaN ] ; %Burgess 2010 PostStroke

C3L = C3(:,2:10);
bws3 = repmat(bws(2:10),2,1);
C3_lm = fitlm(bws3(:),C3L(:));

C3 = [fillmissing(C3(1,:),'linear','Endvalues','none');
        fillmissing(C3(2,:),'linear','Endvalues','none')];

%treadmill, NI
C4 = [ NaN, 1, NaN, NaN, 1.0189,  NaN,   NaN,  1,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN] ; %Hesse 1999 Paretic

C4_lm = fitlm(bws(2:8),C4(2:8));

C4 = fillmissing(C4(1,:),'linear','Endvalues','none');

C1M = mean(C1,'omitnan');
C1S = std(C1,'omitnan');
C2M = mean(C2,'omitnan');
C2S = std(C2,'omitnan');
C3M = mean(C3,'omitnan');
C3S = std(C3,'omitnan');
C4S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0,0,0] ; %Nil
CM = [C1M;C2M;C3M;C4]';
CS = [C1S;C2S;C3S;C4S]';


Colour = [r1;b1;g1;o1];


figure 
superbar(bws,CM, 'E', CS,'BarFaceColor', permute(Colour, [4 1 2 3]));
grid on
grid minor
axis([-10 80 0 1.5])
xticks([-10 0 10 20 30 40 50 60 70 80])
xticklabels({'No BWS', '0', '10', '20', '30', '40', '50', '60', '70', '80'})
set(gca,'fontsize',36)
ylabel('Cadence','FontSize',36,'FontWeight','bold')
xlabel('Percentage Body weight unloading (BWU)','FontSize',36,'FontWeight','bold')
hold on
C1M_est = 5.8765e-05.*bws(2:17) + 0.9964;
plot(bws(2:17),C1M_est,'r--','linewidth',2) 
C2M_est = -6.7135e-04.*bws(2:10) + 1.0003;
plot(bws(2:10),C2M_est,'b--','linewidth',2)
C3M_est = -0.0015.*bws(2:10) + 1.0120;
plot(bws(2:10),C3M_est,'g--','linewidth',2)
C4M_est = (1.460e-17).*bws(2:8) + 1.0063;
plot(bws(2:8),C4M_est,'color',o1,'linestyle','--','linewidth',2)
%% Total Stance Phase

%bws =  -5    0     5    10    15    20    25    30    35    40    45    50   55    60    65    70
% Treadmill healthy
ST1 = [ NaN, 1, NaN, NaN, NaN,  NaN,   NaN,  0.9018,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN , NaN, NaN; %Stephens 1999
        NaN, 75.24/75.24, NaN, NaN, NaN,  NaN,   NaN,  NaN,  75.03/75.24,  NaN, NaN,  73.45/75.24,  NaN, NaN,  NaN,  NaN, 71.18/75.24, NaN ; %Ivanenko 2002
        NaN, 64.1/64.1, NaN, 64.1/64.1, NaN,  NaN,   NaN,  63.5/64.1,  NaN,  NaN, NaN,  62.5/64.1,  NaN, NaN,  NaN,  60.1/64.1, NaN, NaN ; %Threlkeld 2003
        NaN, 77.5/77.5, NaN, NaN, NaN, NaN,71.32/77.5, NaN,NaN,NaN,NaN,68.29/77.5, NaN,NaN,NaN,NaN,67.24/77.5, NaN ] ; %Van Hedel 2006

ST1L = ST1(:,2:17);
bws1 = repmat(bws(2:17),4,1);
ST1_lm = fitlm(bws1(:),ST1L(:));

ST1 = [fillmissing(ST1(1,:),'linear','Endvalues','none');
        fillmissing(ST1(2,:),'linear','Endvalues','none');
        fillmissing(ST1(3,:),'linear','Endvalues','none')
        fillmissing(ST1(4,:),'linear','Endvalues','none')];

%overground, healthy    
ST2 = [ 64.98/66.94, 66.94/66.94, NaN, 66.64/66.94, NaN,  64.54/66.94,   NaN,  63.35/66.94,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN  ; %Patino 2007    
        59.48/59.69, 59.69/59.69, NaN, NaN, 58.88/59.69,  NaN,   NaN,  55.10/59.69,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN  ; %Fischer 2014  
        NaN, 69.83/69.83, NaN, 64.82/69.83, NaN,  63.19/69.83,   NaN,  62.61/69.83,  NaN,  60.30/69.83, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN ]; %Mun 2016

ST2L = ST2(:,2:10);
bws2 = repmat(bws(2:10),3,1);
ST2_lm = fitlm(bws2(:),ST2L(:));

ST2 = [fillmissing(ST2(1,:),'linear','Endvalues','none');
        fillmissing(ST2(2,:),'linear','Endvalues','none');
        fillmissing(ST2(3,:),'linear','Endvalues','none')];

%overground, NI - non paretic leg
ST3 = [80.60/81.46, 81.21/81.46, NaN, NaN, NaN,  NaN,   NaN,  81.46/81.46,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN]  ; %Sousa 2009 NonParetic Leg
ST3_lm = fitlm(bws(2:8),ST3(2:8));
ST3 = [fillmissing(ST3(1,:),'linear','Endvalues','none')];
%overground, NI - paretic leg
ST4 = [66.88/68.04, 68.04/68.04, NaN, NaN, NaN,  NaN,   NaN,  66.25/68.04,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN] ; %Sousa 2009 Paretic Leg   
ST4_lm = fitlm(bws(2:8),ST4(2:8));
ST4 = [fillmissing(ST4(1,:),'linear','Endvalues','none')];
%treadmill, NI - non paretic leg
ST5 = [ NaN, 1, NaN, NaN, 0.9815,  NaN,   NaN,  0.9576,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN] ; %Hesse 1999 non Paretic
ST5_lm = fitlm(bws(2:8),ST5(2:8));
ST5 = fillmissing(ST5(1,:),'linear','Endvalues','none');
%treadmill, NI - paretic leg
ST6 = [ NaN, 1, NaN, NaN, 0.9852,  NaN,   NaN,  0.9734,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN] ; %Hesse 1999 Paretic
ST6_lm = fitlm(bws(2:8),ST6(2:8));
ST6 = fillmissing(ST6(1,:),'linear','Endvalues','none');

ST1M = mean(ST1,'omitnan');
ST1S = std(ST1,'omitnan');
ST2M = mean(ST2,'omitnan');
ST2S = std(ST2,'omitnan');
ST3S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0,0,0] ; %Nil
ST4S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0,0,0] ; %Nil
ST5S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0,0,0] ; %Nil
ST6S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0,0,0] ; %Nil

STM = [ST1M;ST2M;ST3;ST4;ST5;ST6]';
STS = [ST1S;ST2S;ST3S;ST4S;ST5S;ST6S]';


figure 
superbar(bws,STM, 'E', STS,'BarFaceColor', permute(Colour6, [6 1 2 3 4 5]));
grid on
grid minor
axis([-10 80 0 1.5])
xticks([-10 0 10 20 30 40 50 60 70 80])
xticklabels({'No BWS', '0', '10', '20', '30', '40', '50', '60', '70', '80'})
set(gca,'fontsize',36)
ylabel('Total Stance Phase','FontSize',36,'FontWeight','bold')
xlabel('Percentage Body weight unloading (BWU)','FontSize',36,'FontWeight','bold')
hold on
ST1M_est = -0.0011.*bws(2:17) + 0.9963;
plot(bws(2:17),ST1M_est,'r--','linewidth',2) 
ST2M_est = -0.0029.*bws(2:10) + 1.0011;
plot(bws(2:10),ST2M_est,'b--','linewidth',2)
ST3M_est = 0.000102299697192911.*bws(2:8) + 0.9969;
plot(bws(2:8),ST3M_est,'g--','linewidth',2)
ST4M_est = -0.000876935136194388.*bws(2:8) + 1;
plot(bws(2:8),ST4M_est,'m--','linewidth',2)
ST5M_est = -0.0014.*bws(2:8) + 1.0009;
plot(bws(2:8),ST5M_est,'color',o1,'linestyle','--','linewidth',2)
ST6M_est = -0.000886666666666648.*bws(2:8) + 0.9994;
plot(bws(2:8),ST6M_est,'color',y1,'linestyle','--','linewidth',2)
%% iDLS
%bws =  0     5    10    15    20    25    30    35    40    45    50   55    60    65    70
%treadmill-healthy
iDLS1 = [  NaN, 14.1/14.1, NaN, 14.1/14.1, NaN,  NaN,   NaN,  13.4/14.1,  NaN,  NaN, NaN,  12.5/14.1,  NaN, NaN,  NaN,  9.8/14.1, NaN, NaN ; %Threlkeld 2003
           NaN, 28.4585/28.4585, NaN, NaN, NaN, NaN,21.3539/28.4585, NaN,NaN,NaN,NaN,18.5771/28.4585, NaN,NaN,NaN,NaN,17.7866/28.4585, NaN  ; %Van Hedel 2006
           NaN, 15.7954/15.7954, NaN, NaN, NaN, NaN,NaN, NaN,NaN,NaN,NaN,12.5974/15.7954, NaN,NaN,NaN,NaN,NaN, NaN ] ; %Van Kammen

iDLS1L = iDLS1(:,2:17);
bws1 = repmat(bws(2:17),3,1);
iDLS1_lm = fitlm(bws1(:),iDLS1L(:));

iDLS1 = [fillmissing(iDLS1(1,:),'linear','Endvalues','none');
        fillmissing(iDLS1(2,:),'linear','Endvalues','none');
        fillmissing(iDLS1(3,:),'linear','Endvalues','none')];

%overground healthy
iDLS2 = [  13.20/16.82, 16.82/16.82, NaN, 14.67/16.82, NaN,  14.10/16.82,   NaN,  13/16.82,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN ] ; %Patino 2007
iDLS2_lm = fitlm(bws(2:8),iDLS2(2:8));
iDLS2 = [fillmissing(iDLS2(1,:),'linear','Endvalues','none')];
%overground NI nonparetic        
iDLS3 = [  26.59/27.11, 27.11/27.11, NaN, NaN, NaN,  NaN,   NaN,  27.68/27.11,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN , NaN, NaN] ; %Sousa 2009 NonParetic Leg
iDLS3_lm = fitlm(bws(2:8),iDLS3(2:8));
iDLS3 = [fillmissing(iDLS3(1,:),'linear','Endvalues','none')];
%overground NI paretic        
iDLS4 = [  21.93/22.42, 22.42/22.42, NaN, NaN, NaN,  NaN,   NaN,  19.14/22.42,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN , NaN, NaN]; %Sousa 2009 Paretic Leg
iDLS4_lm = fitlm(bws(2:8),iDLS4(2:8));
iDLS4 = [fillmissing(iDLS4(1,:),'linear','Endvalues','none')];
%treadmill NI nonparetic
iDLS5 = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0,0,0] ; %Nil
%treadmill patient paretic
iDLS6 = [ NaN, 1, NaN, NaN, 0.9,  NaN,   NaN,  0.8591,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN] ; %Hesse 1999 Paretic
iDLS6_lm = fitlm(bws(2:8),iDLS6(2:8));
iDLS6 = fillmissing(iDLS6(1,:),'linear','Endvalues','none');

iDLS1M = mean(iDLS1,'omitnan');
iDLS1S = std(iDLS1,'omitnan');
iDLS2S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0,0,0] ; %Nil
iDLS3S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0,0,0] ; %Nil
iDLS4S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0,0,0] ; %Nil
iDLS5S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0,0,0] ; %Nil
iDLS6S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0,0,0] ; %Nil

iDLSM = [iDLS1M;iDLS2;iDLS3;iDLS4;iDLS5;iDLS6]';
iDLSS = [iDLS1S;iDLS2S;iDLS3S;iDLS4S;iDLS5S;iDLS6S]';

figure 
superbar(bws,iDLSM, 'E', iDLSS,'BarFaceColor', permute(Colour6, [6 1 2 3 4 5]));
grid on
grid minor
axis([-10 80 0 1.5])
xticks([-10 0 10 20 30 40 50 60 70 80])
xticklabels({'No BWS', '0', '10', '20', '30', '40', '50', '60', '70', '80'})
set(gca,'fontsize',36)
ylabel('Initial DLS','FontSize',36,'FontWeight','bold')
xlabel('Percentage Body weight unloading (BWU)','FontSize',36,'FontWeight','bold')
hold on
iDLS1M_est = -0.0047.*bws(2:17) + 1.0030;
plot(bws(2:17),iDLS1M_est,'r--','linewidth',2) 
iDLS2M_est = -0.0072.*bws(2:8) + 0.9781;
plot(bws(2:8),iDLS2M_est,'b--','linewidth',2)
iDLS3M_est = 0.000700848395426060.*bws(2:8) + 1;
plot(bws(2:8),iDLS3M_est,'g--','linewidth',2)
iDLS4M_est = -0.0049.*bws(2:8) + 1;
plot(bws(2:8),iDLS4M_est,'m--','linewidth',2)
iDLS6M_est = -0.0047.*bws(2:8) + 0.9901;
plot(bws(2:8),iDLS6M_est,'color',y1,'linestyle','--','linewidth',2)
%% SLS
%bws =  0     5    10    15    20    25    30    35    40    45    50   55    60    65    70
%treadmill-healthy
SLS1 = [NaN, 22.2115/22.2115, NaN, NaN, NaN, NaN,29.0561/22.2115, NaN,NaN,NaN,NaN,31.9629/22.2115, NaN,NaN,NaN,NaN,32.8834/22.2115, NaN  ; %Van Hedel 2006
        NaN, 34.5132/34.5132, NaN, NaN, NaN, NaN,NaN, NaN,NaN,NaN,NaN,37.2554/34.5132, NaN,NaN,NaN,NaN,NaN, NaN ] ; %Van Kammen

SLS1L = SLS1(:,2:17);
bws1 = repmat(bws(2:17),2,1);
SLS1_lm = fitlm(bws1(:),SLS1L(:));

SLS1 = [fillmissing(SLS1(1,:),'linear','Endvalues','none');
        fillmissing(SLS1(2,:),'linear','Endvalues','none')];

%overground healthy
SLS2 = [36.56/34.49, 34.49/34.49, NaN, 35.48/34.49, NaN,  35.42/34.49,   NaN,  36.37/34.49,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN,NaN,NaN ; %Patino 2007
        40.60/40.09, 40.09/40.09, NaN, NaN, 43.48/40.09,  NaN,   NaN,  44.08/40.09,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN ,NaN,NaN; %Fischer 2014  
        NaN, 49.78/49.78, NaN, 48.06/49.78, NaN,  47.55/49.78,   NaN,  48.29/49.78,  NaN,  45.50/49.78, NaN,  NaN,  NaN, NaN,  NaN,  NaN ,NaN,NaN]; %Mun 2016

SLS2L = SLS2(:,2:10);
bws2 = repmat(bws(2:10),3,1);
SLS2_lm = fitlm(bws2(:),SLS2L(:));

SLS2 = [fillmissing(SLS2(1,:),'linear','Endvalues','none');
        fillmissing(SLS2(2,:),'linear','Endvalues','none');
        fillmissing(SLS2(3,:),'linear','Endvalues','none')];

%overground NI nonparetic 
SLS3 = [32.19/30.56, 30.56/30.56, NaN, NaN, NaN,  NaN,   NaN,  31.56/30.56,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN,NaN,NaN] ; %Sousa 2009 NonParetic Leg
SLS3_lm = fitlm(bws(2:8),SLS3(2:8));
SLS3 = [fillmissing(SLS3(1,:),'linear','Endvalues','none')];
%overground NI paretic 
SLS4 =  [18.49/18.09, 18.09/18.09, NaN, NaN, NaN,  NaN,   NaN,  18.42/18.09,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN,NaN,NaN] ; %Sousa 2009 Paretic Leg
SLS4_lm = fitlm(bws(2:8),SLS4(2:8));
SLS4 = [fillmissing(SLS4(1,:),'linear','Endvalues','none')];
%treadmill NI nonparetic
SLS5 = [ NaN, 1, NaN, NaN, 1.0309,  NaN,   NaN,  1.0556,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN] ; %Hesse 1999 Paretic
SLS5_lm = fitlm(bws(2:8),SLS5(2:8));
SLS5 = fillmissing(SLS5(1,:),'linear','Endvalues','none');
%treadmill NI paretic
SLS6 = [ NaN, 1, NaN, NaN, 01.0449,  NaN,   NaN,  1.1306,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN] ; %Hesse 1999 Paretic
SLS6_lm = fitlm(bws(2:8),SLS6(2:8));
SLS6 = fillmissing(SLS6(1,:),'linear','Endvalues','none');

SLS1M = mean(SLS1,'omitnan');
SLS1S = std(SLS1,'omitnan');
SLS2M = mean(SLS2,'omitnan');
SLS2S = std(SLS2,'omitnan');
SLS3S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0,0,0] ; %Nil
SLS4S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0,0,0] ; %Nil
SLS5S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0,0,0] ; %Nil
SLS6S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0,0,0] ; %Nil

SLSM = [SLS1M;SLS2M;SLS3;SLS4;SLS6;SLS6]';
SLSS = [SLS1S;SLS2S;SLS3S;SLS4S;SLS5S;SLS6S]';


figure 
superbar(bws,SLSM, 'E', SLSS,'BarFaceColor', permute(Colour6, [6 1 2 3 4 5]));
grid on
grid minor
axis([-10 80 0 1.8])
xticks([-10 0 10 20 30 40 50 60 70 80])
xticklabels({'No BWS', '0', '10', '20', '30', '40', '50', '60', '70', '80'})
set(gca,'fontsize',36)
ylabel('SLS Phase','FontSize',36,'FontWeight','bold')
xlabel('Percentage Body weight unloading (BWU)','FontSize',36,'FontWeight','bold')
hold on
SLS1M_est = 0.0057.*bws(2:17) + 1.0281;
plot(bws(2:17),SLS1M_est,'r--','linewidth',2) 
SLS2M_est = -2.7391e-04.*bws(2:10) + 1.0219;
plot(bws(2:10),SLS2M_est,'b--','linewidth',2)
SLS3M_est = 0.0011.*bws(2:8) + 1;
plot(bws(2:8),SLS3M_est,'g--','linewidth',2)
SLS4M_est = 0.000608070757324505.*bws(2:8) + 1;
plot(bws(2:8),SLS4M_est,'m--','linewidth',2)
SLS5M_est = 0.0019.*bws(2:8) + 1.0010;
plot(bws(2:8),SLS5M_est,'color',o1,'linestyle','--','linewidth',2)
SLS6M_est = 0.0044.*bws(2:8) + 0.9932;
plot(bws(2:8),SLS6M_est,'color',y1,'linestyle','--','linewidth',2)