% Experimental data from literature - figure 3
% Salil Apte
% 23.03.2017
clear all
clc

addpath(genpath('superbar-master'))
bws = -5:5:80;
r1 = [228 26 28]./255;
b1 = [55 126 184]./255;
g1 = [77 175 74]./255;  

l1 = [152 78 163]./255;
Colour = [r1;b1;g1;l1];
%% GRFs AP D
%bws =  0     5    10    15    20    25    30    35    40    45    50   55    60    65    70
% Treadmill - healthy
DP1 =  [NaN, -1, NaN, NaN, NaN,  -0.80613,   NaN,  NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN ; %Franz 2007   
        NaN, -1, NaN, NaN, NaN, NaN, -92.1/111.3, NaN, NaN,NaN, NaN, -74.9/111.3, NaN, NaN, NaN, NaN, NaN, NaN; %McGowan2008
        NaN, -1, NaN, NaN, NaN, -0.71608, NaN, NaN, NaN,-0.50835, NaN, NaN, NaN, NaN, NaN, NaN, NaN, NaN]; %Lewek2010

DP1L = DP1(:,2:12);
bws1 = repmat(bws(2:12),3,1);
DP1_lm = fitlm(bws1(:),DP1L(:));

DP1 = [fillmissing(DP1(1,:),'linear','Endvalues','none');
       fillmissing(DP1(2,:),'linear','Endvalues','none');
       fillmissing(DP1(3,:),'linear','Endvalues','none')];        

% Overground - healthy
DP2 = [ -13.63/9.82, -1, NaN, -8.79/9.82, NaN,  -6.71/9.82,   NaN,  -5.33/9.82,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN ; %Patino 2007
        NaN, -1, NaN, NaN, -8.65/12.6,  NaN,   NaN,  -6.15/12.6,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN]; % Barela 2014 ave LR

DP2L = DP2(:,2:8);
bws2 = repmat(bws(2:8),2,1);
DP2_lm = fitlm(bws2(:),DP2L(:));
    
DP2 = [fillmissing(DP2(1,:),'linear','Endvalues','none');
       fillmissing(DP2(2,:),'linear','Endvalues','none')];

DP3 = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
DP4 = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;

DP1M = mean(DP1,'omitnan');
DP1S = std(DP1,'omitnan');
DP2M = mean(DP2,'omitnan');
DP2S = std(DP2,'omitnan');
DP3S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
DP4S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
DPM = [DP1M;DP2M;DP3;DP4]';
DPS = [DP1S;DP2S;DP3S;DP4S]';

figure 
superbar(bws,DPM, 'E', DPS,'BarFaceColor', permute(Colour, [4 1 2 3]));
grid on
grid minor
axis([-10 80 -1.5 0])
xticks([-10 0 10 20 30 40 50 60 70 80])
xticklabels({'No BWS', '0', '10', '20', '30', '40', '50', '60', '70', '80'})
set(gca,'fontsize',36)
ylabel('Anteroposterior GRF - I','FontSize',36,'FontWeight','bold')
xlabel('Percentage Body weight unloading (BWU)','FontSize',36,'FontWeight','bold')
hold on
DP1M_est = 0.0085.*bws(2:12) - 0.9810;
plot(bws(2:12),DP1M_est,'r--','linewidth',2) 
DP2M_est = 0.0164.*bws(2:8) - 1.0028;
plot(bws(2:8),DP2M_est,'b--','linewidth',2) 
%% GRFS AP A
% Treadmill - healthy
AP1 = [NaN, 1, NaN, NaN, NaN,  0.7383,   NaN,  NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN ; %Franz 2007    
       NaN, 1, NaN, NaN, NaN, NaN, 106.9/125.9, NaN, NaN,NaN, NaN, 77.2/125.9, NaN, NaN, NaN, NaN, NaN, NaN; %McGowan2008       
       NaN, 1, NaN, NaN, NaN, 0.822, NaN, NaN, NaN,0.7034, NaN, NaN, NaN, NaN, NaN, NaN, NaN, NaN]; %Lewek2010

AP1L = AP1(:,2:12);
bws1 = repmat(bws(2:12),3,1);
AP1_lm = fitlm(bws1(:),AP1L(:));

AP1 = [fillmissing(AP1(1,:),'linear','Endvalues','none');
       fillmissing(AP1(2,:),'linear','Endvalues','none');
       fillmissing(AP1(3,:),'linear','Endvalues','none')];           

% Overground - healthy
AP2 = [  16.22/15.20, 1, NaN, 12.20/15.20, NaN,  10.35/15.20,   NaN,  10.44/15.20,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN ; %Patino 2007
         NaN, 1, NaN, NaN, 9.1/12.95,  NaN,   NaN,  7.2/12.95,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN]; % Barela 2014 ave LR   

AP2L = AP2(:,2:8);
bws2 = repmat(bws(2:8),2,1);
AP2_lm = fitlm(bws2(:),AP2L(:));

AP2 = [fillmissing(AP2(1,:),'linear','Endvalues','none');
       fillmissing(AP2(2,:),'linear','Endvalues','none')];


AP3 = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
AP4 = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;

AP1M = mean(AP1,'omitnan');
AP1S = std(AP1,'omitnan');
AP2M = mean(AP2,'omitnan');
AP2S = std(AP2,'omitnan');
AP3S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
AP4S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
APM = [AP1M;AP2M;AP3;AP4]';
APS = [AP1S;AP2S;AP3S;AP4S]';

figure 
superbar(bws,APM, 'E', APS,'BarFaceColor', permute(Colour, [4 1 2 3]));
grid on
grid minor
axis([-10 80 0 1.5])
xticks([-10 0 10 20 30 40 50 60 70 80])
xticklabels({'No BWS', '0', '10', '20', '30', '40', '50', '60', '70', '80'})
set(gca,'fontsize',36)
ylabel('Anteroposterior GRF - II','FontSize',36,'FontWeight','bold')
xlabel('Percentage Body weight unloading (BWU)','FontSize',36,'FontWeight','bold')
hold on
AP1M_est = -0.0076.*bws(2:12) + 0.9874;
plot(bws(2:12),AP1M_est,'r--','linewidth',2) 
AP2M_est = -0.0126.*bws(2:8) + 0.9645;
plot(bws(2:8),AP2M_est,'b--','linewidth',2)      
     
%% Vertical GRF I

% Treadmill - healthy
VI1 = [ NaN, 1, NaN, NaN, NaN,  NaN,   NaN,  NaN,  0.7406,  NaN, NaN,  0.6250,  NaN, NaN,  NaN,  NaN, 0.325, NaN ; %Ivanenko 2002
        NaN, 1, NaN, NaN, NaN,  0.8226,   NaN,  NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN ; %Franz 2007    
       NaN, 1, NaN, NaN, NaN, 0.8789, NaN, NaN, NaN,0.7920, NaN, NaN, NaN, NaN, NaN, NaN, NaN, NaN]; %Lewek2010

VI1L = VI1(:,2:17);
bws1 = repmat(bws(2:17),3,1);
VI1_lm = fitlm(bws1(:),VI1L(:));

VI1 = [fillmissing(VI1(1,:),'linear','Endvalues','none');
       fillmissing(VI1(2,:),'linear','Endvalues','none');
       fillmissing(VI1(3,:),'linear','Endvalues','none')];          

% Overground - healthy
VI2 =[  97.86/99.88, 1, NaN, 89.26/99.88, NaN,  78.41/99.88,   NaN,  71.33/99.88,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN ; %Patino 2007
        NaN, 1, NaN, NaN, 86.5/104,  NaN,   NaN,  74/104,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN]; % Barela 2014 ave LR 

VI2L = VI2(:,2:8);
bws2 = repmat(bws(2:8),2,1);
VI2_lm = fitlm(bws2(:),VI2L(:));

VI2 = [fillmissing(VI2(1,:),'linear','Endvalues','none');
       fillmissing(VI2(2,:),'linear','Endvalues','none')];  

VI3 = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
VI4 = [ NaN, 1, NaN, NaN, 0.9433,  NaN,   NaN,  0.8027,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN] ; %Hesse 1999 Paretic
VI4_lm = fitlm(bws(2:8),VI4(2:8));
VI4 = fillmissing(VI4(1,:),'linear','Endvalues','none');

VI1M = mean(VI1,'omitnan');
VI1S = std(VI1,'omitnan');
VI2M = mean(VI2,'omitnan');
VI2S = std(VI2,'omitnan');
VI3S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
VI4S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
VIM = [VI1M;VI2M;VI3;VI4]';
VIS = [VI1S;VI2S;VI3S;VI4S]';

figure 
superbar(bws,VIM, 'E', VIS,'BarFaceColor', permute(Colour, [4 1 2 3]));
grid on
grid minor
axis([-10 80 0 1.5])
xticks([-10 0 10 20 30 40 50 60 70 80])
xticklabels({'No BWS', '0', '10', '20', '30', '40', '50', '60', '70', '80'})
set(gca,'fontsize',36)
ylabel('Vertical GRF - I','FontSize',36,'FontWeight','bold')
xlabel('Percentage Body weight unloading (BWU)','FontSize',36,'FontWeight','bold')
hold on
VI1M_est = -0.0083.*bws(2:17) + 1.0191;
plot(bws(2:17),VI1M_est,'r--','linewidth',2) 
VI2M_est = -0.0096.*bws(2:8) + 0.9926;
plot(bws(2:8),VI2M_est,'b--','linewidth',2) 
VI4M_est = -0.0066.*bws(2:8) + 1.0140;
plot(bws(2:8),VI4M_est,'m--','linewidth',2) 
%% Vertical GRF II

% Treadmill - healthy
VII1 = [ NaN, 1, NaN, NaN, NaN,  NaN,   NaN,  NaN,  0.7647,  NaN, NaN,  0.6094,  NaN, NaN,  NaN,  NaN, 0.2918, NaN ; %Ivanenko 2002
        NaN, 1, NaN, NaN, NaN,  0.7805,   NaN,  NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN ; %Franz 2007    
        NaN, 1, NaN, NaN, NaN, 0.8516, NaN, NaN, NaN,0.7280, NaN, NaN, NaN, NaN, NaN, NaN, NaN, NaN]; %Lewek2010

VII1L = VII1(:,2:17);
bws1 = repmat(bws(2:17),3,1);
VII1_lm = fitlm(bws1(:),VII1L(:));

VII1 = [fillmissing(VII1(1,:),'linear','Endvalues','none');
       fillmissing(VII1(2,:),'linear','Endvalues','none');
       fillmissing(VII1(3,:),'linear','Endvalues','none')];

% Overground - healthy
VII2 = [103.15/97.81, 1, NaN, 80.56/97.81, NaN,  71.51/97.81,   NaN,  61.58/97.81,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN ; %Patino 2007
        NaN, 1, NaN, NaN, 76/94,  NaN,   NaN,  66.5/94,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN]; % Barela 2014 ave LR    

VII2L = VII2(:,2:8);
bws2 = repmat(bws(2:8),2,1);
VII2_lm = fitlm(bws2(:),VII2L(:));

VII2 = [fillmissing(VII2(1,:),'linear','Endvalues','none');
       fillmissing(VII2(2,:),'linear','Endvalues','none')];

VII3 = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
VII4 = [ NaN, 1, NaN, NaN, 0.9042,  NaN,   NaN,  0.7942,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN] ; %Hesse 1999 Paretic
VII4_lm = fitlm(bws(2:8),VII4(2:8));
VII4 = fillmissing(VII4(1,:),'linear','Endvalues','none');


VII1M = mean(VII1,'omitnan');
VII1S = std(VII1,'omitnan');
VII2M = mean(VII2,'omitnan');
VII2S = std(VII2,'omitnan');
VII3S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
VII4S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
VIIM = [VII1M;VII2M;VII3;VII4]';
VIIS = [VII1S;VII2S;VII3S;VII4S]';

figure 
superbar(bws,VIIM, 'E', VIIS,'BarFaceColor', permute(Colour, [4 1 2 3]));
grid on
grid minor
axis([-10 80 0 1.5])
xticks([-10 0 10 20 30 40 50 60 70 80])
xticklabels({'No BWS', '0', '10', '20', '30', '40', '50', '60', '70', '80'})
set(gca,'fontsize',36)
ylabel('Vertical GRF - II','FontSize',36,'FontWeight','bold')
xlabel('Percentage Body weight unloading (BWU)','FontSize',36,'FontWeight','bold')
hold on
VII1M_est = -0.0087.*bws(2:17) + 1.0123;
plot(bws(2:17),VII1M_est,'r--','linewidth',2) 
VII2M_est = -0.0110.*bws(2:8) + 0.9787;
plot(bws(2:8),VII2M_est,'b--','linewidth',2) 
VII4M_est = -0.0069.*bws(2:8) + 1.0024;
plot(bws(2:8),VII4M_est,'m--','linewidth',2) 
%% Energy Cost of walking

% Treadmill - healthy
%bws =  -5    0   5    10    15    20    25    30    35    40    45    50     55    60    65    70
ECW1 = [ NaN, 1, NaN, NaN, NaN,   NaN, 0.9906, NaN,  NaN, NaN , NaN, 0.8391,  NaN, NaN,  NaN,  NaN, 0.6673, NaN; % Griffin 1999
         NaN, 1, NaN, NaN, NaN,  13.41/14.30,   NaN,  NaN,  NaN,  12.5/14.30, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN; % Colby 1999
         NaN, 1, NaN, NaN, NaN, NaN, 0.9781, NaN, NaN, NaN, NaN, 0.9301, NaN, NaN, NaN, NaN, 0.8659, NaN; %Grabowski 2004
         NaN, 1, NaN, NaN, NaN, 0.9017, NaN, NaN, NaN, 0.8306, NaN, NaN, NaN, NaN, NaN, NaN, NaN, NaN ; %Thomas 2007
         NaN, 1, NaN, NaN, NaN,  NaN,   NaN,  11.97/13.21,  NaN,  NaN, NaN, NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN ]; %Danielsson - Control

ECW1L = ECW1(:,2:17);
bws1 = repmat(bws(2:17),5,1);
ECW1_lm = fitlm(bws1(:),ECW1L(:));

ECW1 = [fillmissing(ECW1(1,:),'linear','Endvalues','none');
        fillmissing(ECW1(2,:),'linear','Endvalues','none');
        fillmissing(ECW1(3,:),'linear','Endvalues','none');
        fillmissing(ECW1(4,:),'linear','Endvalues','none')
        fillmissing(ECW1(5,:),'linear','Endvalues','none')];

ECW2 = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
ECW3 = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;    
ECW4 = [ NaN, 1, NaN, NaN, NaN,  NaN,   NaN,  9.42/10.82,  NaN,  NaN, NaN, NaN,  NaN, NaN,  NaN,  NaN , NaN, NaN]; %Danielsson - Patient
ECW4_lm = fitlm(bws(2:8),ECW4(2:8));
ECW4 = [fillmissing(ECW4(1,:),'linear','Endvalues','none')];

ECW1M = mean(ECW1,'omitnan');
ECW1S = std(ECW1,'omitnan');
ECW2S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
ECW3S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
ECW4S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
ECWM = [ECW1M;ECW2;ECW3;ECW4]';
ECWS = [ECW1S;ECW2S;ECW3S;ECW4S]';

figure 
superbar(bws,ECWM, 'E', ECWS,'BarFaceColor', permute(Colour, [4 1 2 3]));
grid on
grid minor
axis([-10 80 0 1.8])
xticks([-10 0 10 20 30 40 50 60 70 80])
xticklabels({'No BWS', '0', '10', '20', '30', '40', '50', '60', '70', '80'})
set(gca,'fontsize',36)
ylabel('Energy Cost of Walking','FontSize',36,'FontWeight','bold')
xlabel('Percentage Body weight unloading (BWU)','FontSize',36,'FontWeight','bold')
hold on
ECW1M_est = -0.0030.*bws(2:17) + 1.0044;
plot(bws(2:17),ECW1M_est,'r--','linewidth',2) 
ECW4M_est = -0.0043.*bws(2:8) + 1;
plot(bws(2:8),ECW4M_est,'m--','linewidth',2) 
%% Heart Rate

% Treadmill - healthy
HR1 = [   NaN, 90.84/90.84, NaN, NaN, NaN,  92.11/90.84,   NaN,  NaN,  NaN,  88.11/90.84, NaN,  NaN,  NaN, NaN,  NaN,  NaN,  NaN,  NaN; % Colby 1999
        NaN, 1, NaN, NaN, NaN, 1.0187, NaN, NaN, NaN, 1.01, NaN, NaN, NaN, NaN, NaN, NaN, NaN, NaN ] ; %Thomas 2007

HR1L = HR1(:,2:10);
bws1 = repmat(bws(2:10),2,1);
HR1_lm = fitlm(bws1(:),HR1L(:));

HR1 = [fillmissing(HR1(1,:),'linear','Endvalues','none');
        fillmissing(HR1(2,:),'linear','Endvalues','none')];

HR2 = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
HR3 = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;    
HR4 = [ NaN, 1, NaN, NaN, NaN,  NaN,   NaN,  96.7/100.3,  NaN,  NaN, NaN, NaN,  NaN, NaN,  NaN,  NaN,  NaN,  NaN ]; %Danielsson - Patient
HR4_lm = fitlm(bws(2:8),HR4(2:8));
HR4 = [fillmissing(HR4(1,:),'linear','Endvalues','none')];

HR1M = mean(HR1,'omitnan');
HR1S = std(HR1,'omitnan');
HR2S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
HR3S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
HR4S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
HRM = [HR1M;HR2;HR3;HR4]';
HRS = [HR1S;HR2S;HR3S;HR4S]';

figure 
superbar(bws,HRM, 'E', HRS,'BarFaceColor', permute(Colour, [4 1 2 3]));
grid on
grid minor
axis([-10 80 0 1.8])
xticks([-10 0 10 20 30 40 50 60 70 80])
xticklabels({'No BWS', '0', '10', '20', '30', '40', '50', '60', '70', '80'})
set(gca,'fontsize',36)
ylabel('Heart Rate','FontSize',36,'FontWeight','bold')
xlabel('Percentage Body weight unloading (BWU)','FontSize',36,'FontWeight','bold')
hold on
HR1M_est = -2.5066e-04.*bws(2:10) + 1.0071;
plot(bws(2:10),HR1M_est,'r--','linewidth',2) 
HR4M_est = -0.0012.*bws(2:8) + 1;
plot(bws(2:8),HR4M_est,'m--','linewidth',2) 

