% Experimental data from literature - figure 4
% Salil Apte
% 23.03.2017
clear all
clc

addpath(genpath('superbar-master'))
bws = -5:5:80;
r1 = [228 26 28]./255;
b1 = [55 126 184]./255;
g1 = [77 175 74]./255;
l1 = [152 78 163]./255;
Colour = [r1;b1;g1;l1];
%% MG

% Treadmill - healthy
MG1 = [ NaN, 1, NaN, NaN, NaN,  0.9,   NaN,  NaN,  NaN,  0.919, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN; % Colby 1999
        NaN, 1, NaN, NaN, NaN, NaN, 0.772, NaN, NaN, NaN, NaN, 0.4773, NaN, NaN, NaN, NaN, 0.3369, NaN; %Dietz 1997
        NaN, 1, NaN, NaN, NaN, NaN, 0.772, NaN, NaN, NaN, NaN, 0.4912, NaN, NaN, NaN, NaN, 0.4912, NaN; %Dietz 1998
        NaN, 1, NaN, NaN, NaN, NaN, 0.8529, NaN, NaN, NaN, NaN, 0.6201, NaN, NaN, NaN, NaN, 0.4446, NaN; %Ferris 2001
        NaN, 1, NaN, NaN, NaN, 0.8928, NaN, NaN, NaN,0.9135, NaN, NaN, NaN, NaN, NaN, NaN, NaN, NaN]; %Lewek2010

MG1L = MG1(:,2:17);
bws1 = repmat(bws(2:17),5,1);
MG1_lm = fitlm(bws1(:),MG1L(:));

MG1 = [fillmissing(MG1(1,:),'linear','Endvalues','none');
        fillmissing(MG1(2,:),'linear','Endvalues','none');
        fillmissing(MG1(3,:),'linear','Endvalues','none');
        fillmissing(MG1(4,:),'linear','Endvalues','none')
        fillmissing(MG1(5,:),'linear','Endvalues','none')];       

MG2 = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
MG3 = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
MG4 = [NaN, 1, NaN, NaN, NaN, NaN, 0.7286, NaN, NaN, NaN, NaN, 0.5402, NaN, NaN, NaN, NaN, 0.4277, NaN; %Dietz 1997
        NaN, 1, NaN, NaN, NaN, NaN, 0.7318, NaN, NaN, NaN, NaN, 0.5389, NaN, NaN, NaN, NaN, 0.4284, NaN]; %Dietz 1998

MG4L = MG4(:,2:17);
bws4 = repmat(bws(2:17),2,1);
MG4_lm = fitlm(bws4(:),MG4L(:));

MG4 = [fillmissing(MG4(1,:),'linear','Endvalues','none');
        fillmissing(MG4(2,:),'linear','Endvalues','none')];

MG1M = mean(MG1,'omitnan');
MG1S = std(MG1,'omitnan');
MG2S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
MG3S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
MG4M = mean(MG4,'omitnan');
MG4S = std(MG4,'omitnan');
MGM = [MG1M;MG2;MG3;MG4M]';
MGS = [MG1S;MG2S;MG3S;MG4S]';

figure 
superbar(bws,MGM, 'E', MGS,'BarFaceColor', permute(Colour, [4 1 2 3]));
grid on
grid minor
axis([-10 80 0 1.5])
xticks([-10 0 10 20 30 40 50 60 70 80])
xticklabels({'No BWS', '0', '10', '20', '30', '40', '50', '60', '70', '80'})
set(gca,'fontsize',36)
ylabel('MG','FontSize',36,'FontWeight','bold')
xlabel('Percentage Body weight unloading (BWU)','FontSize',36,'FontWeight','bold')
hold on
MG1M_est = (-0.0078).*bws(2:17) + 1.0197;
plot(bws(2:17),MG1M_est,'r--','linewidth',2) 
MG4M_est = -0.0076.*bws(2:17) + 0.9604;
plot(bws(2:17),MG4M_est,'m--','linewidth',2) 
%% LG

% Treadmill - healthy
LG1 = [NaN, 1, NaN, NaN, NaN, NaN, NaN, NaN, 0.7617, NaN, NaN, 0.6226, NaN, NaN, NaN, NaN, 0.4848, NaN; %Ivanenko 2002
        NaN, 1, NaN, NaN, NaN, 0.8307, NaN, NaN, NaN,1.0001, NaN, NaN, NaN, NaN, NaN, NaN, NaN, NaN]; %Lewek2010

LG1L = LG1(:,2:17);
bws1 = repmat(bws(2:17),2,1);
LG1_lm = fitlm(bws1(:),LG1L(:));

LG1 = [fillmissing(LG1(1,:),'linear','Endvalues','none');
        fillmissing(LG1(2,:),'linear','Endvalues','none')];

LG2 = [ NaN, 1, NaN, NaN, 0.8770, NaN, NaN, 0.3628,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN, NaN ]; % Fischer 2015 - LG
LG2_lm = fitlm(bws(2:8),LG2(2:8));
LG2 = [fillmissing(LG2(1,:),'linear','Endvalues','none')];
LG3 = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
LG4 = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;

LG1M = mean(LG1,'omitnan');
LG1S = std(LG1,'omitnan');
LG2S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
LG3S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
LG4S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
LGM = [LG1M;LG2;LG3;LG4]';
LGS = [LG1S;LG2S;LG3S;LG4S]';

figure 
superbar(bws,LGM, 'E', LGS,'BarFaceColor', permute(Colour, [4 1 2 3]));
grid on
grid minor
axis([-10 80 0 1.5])
xticks([-10 0 10 20 30 40 50 60 70 80])
xticklabels({'No BWS', '0', '10', '20', '30', '40', '50', '60', '70', '80'})
set(gca,'fontsize',36)
ylabel('LG','FontSize',36,'FontWeight','bold')
xlabel('Percentage Body weight unloading (BWU)','FontSize',36,'FontWeight','bold')
hold on
LG1M_est = -0.0064.*bws(2:17) + 1.0153;
plot(bws(2:17),LG1M_est,'r--','linewidth',2) 
LG2M_est = -0.0212.*bws(2:8) + 1.0652;
plot(bws(2:8),LG2M_est,'b--','linewidth',2) 
%% RF

% Treadmill - healthy
RF1 = [ NaN, 1, NaN, NaN, NaN,  0.916,   NaN,  NaN,  NaN,  0.728, NaN,  NaN,  NaN, NaN,  NaN,  NaN,  NaN,  NaN ; % Colby 1999 - RF
        NaN, 1, NaN, NaN, NaN, NaN, 0.7312, NaN, NaN, NaN, NaN, 0.6578, NaN, NaN, NaN, NaN, 0.6347, NaN; %Dietz 1997
        NaN, 1, NaN, NaN, NaN, NaN, NaN, NaN, 1.3378, NaN, NaN, 1.4106, NaN, NaN, NaN, NaN, 1.5166, NaN]; %Ivanenko 2002

RF1L = RF1(:,2:17);
bws1 = repmat(bws(2:17),3,1);
RF1_lm = fitlm(bws1(:),RF1L(:));

RF1 = [fillmissing(RF1(1,:),'linear','Endvalues','none');
        fillmissing(RF1(2,:),'linear','Endvalues','none');
        fillmissing(RF1(3,:),'linear','Endvalues','none')];

% Overground - healthy
RF2 =  [NaN, 1, NaN, 0.8444, NaN,  0.7333,   NaN,  0.837,  NaN,  0.837, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN ]; %Mun 2016
RF2_lm = fitlm(bws(2:10),RF2(2:10));
RF2 = [fillmissing(RF2(1,:),'linear','Endvalues','none')];
RF3 = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
RF4 = [NaN, 1, NaN, NaN, NaN, NaN, 0.898, NaN, NaN, NaN, NaN, 0.8086, NaN, NaN, NaN, NaN, 0.6033, NaN]; %Dietz 1997
RF4_lm = fitlm(bws(2:17),RF4(2:17));
RF4 = [fillmissing(RF4(1,:),'linear','Endvalues','none')];

RF1M = mean(RF1,'omitnan');
RF1S = std(RF1,'omitnan');
RF2S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
RF3S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
RF4S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
RFM = [RF1M;RF2;RF3;RF4]';
RFS = [RF1S;RF2S;RF3S;RF4S]';

figure 
superbar(bws,RFM, 'E', RFS,'BarFaceColor', permute(Colour, [4 1 2 3]));
grid on
grid minor
axis([-10 80 0 1.8])
xticks([-10 0 10 20 30 40 50 60 70 80])
xticklabels({'No BWS', '0', '10', '20', '30', '40', '50', '60', '70', '80'})
set(gca,'fontsize',36)
ylabel('RF','FontSize',36,'FontWeight','bold')
xlabel('Percentage Body weight unloading (BWU)','FontSize',36,'FontWeight','bold')
hold on
RF1M_est = 0.0013.*bws(2:17) + 0.9518;
plot(bws(2:17),RF1M_est,'r--','linewidth',2) 
RF2M_est = -0.0033.*bws(2:10) + 0.9170;
plot(bws(2:10),RF2M_est,'b--','linewidth',2) 
RF4M_est = -0.0051.*bws(2:17) + 1.0194;
plot(bws(2:17),RF4M_est,'m--','linewidth',2)

%% BF

% Treadmill - healthy
BF1 = [NaN, 1, NaN, NaN, NaN,  0.969,   NaN,  NaN,  NaN,  0.859, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN; % Colby 1999 - BF
       NaN, 1, NaN, NaN, NaN, NaN, 1.1020, NaN, NaN, NaN, NaN, 1.0612, NaN, NaN, NaN, NaN, 1.1633, NaN; %Dietz 1997
       NaN, 1, NaN, NaN, NaN, NaN, NaN, NaN, 1.1442, NaN, NaN, 1.2421, NaN, NaN, NaN, NaN, 1.3401, NaN]; %Ivanenko 2002

BF1L = BF1(:,2:17);
bws1 = repmat(bws(2:17),3,1);
BF1_lm = fitlm(bws1(:),BF1L(:));

BF1 = [fillmissing(BF1(1,:),'linear','Endvalues','none');
        fillmissing(BF1(2,:),'linear','Endvalues','none');
        fillmissing(BF1(3,:),'linear','Endvalues','none')];

% Overground - healthy
BF2 = [NaN, 1, NaN, 0.9009, NaN,  0.8739,   NaN,  0.8649,  NaN,  0.8108, NaN,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN ]; %Mun 2016
BF2_lm = fitlm(bws(2:10),BF2(2:10));
BF2 = [fillmissing(BF2(1,:),'linear','Endvalues','none')];
BF3 = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
BF4 = [NaN, 1, NaN, NaN, NaN, NaN, 0.9661, NaN, NaN, NaN, NaN, 0.7288, NaN, NaN, NaN, NaN, 0.9831, NaN]; %Dietz 1997
BF4_lm = fitlm(bws(2:17),BF4(2:17));
BF4 = [fillmissing(BF4(1,:),'linear','Endvalues','none')];

BF1M = mean(BF1,'omitnan');
BF1S = std(BF1,'omitnan');
BF2S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
BF3S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
BF4S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
BFM = [BF1M;BF2;BF3;BF4]';
BFS = [BF1S;BF2S;BF3S;BF4S]';
figure 
superbar(bws,BFM, 'E', BFS,'BarFaceColor', permute(Colour, [4 1 2 3]));
grid on
grid minor
axis([-10 80 0 1.5])
xticks([-10 0 10 20 30 40 50 60 70 80])
xticklabels({'No BWS', '0', '10', '20', '30', '40', '50', '60', '70', '80'})
set(gca,'fontsize',36)
ylabel('BF','FontSize',36,'FontWeight','bold')
xlabel('Percentage Body weight unloading (BWU)','FontSize',36,'FontWeight','bold')
hold on
BF1M_est = (0.0032).*bws(2:17) + 0.9719;
plot(bws(2:17),BF1M_est,'r--','linewidth',2) 
BF2M_est = -0.0041.*bws(2:10) + 0.9730;
plot(bws(2:10),BF2M_est,'b--','linewidth',2) 
BF4M_est = -0.0012.*bws(2:17) + 0.9627;
plot(bws(2:17),BF4M_est,'m--','linewidth',2)

    
%% TA

% Treadmill - healthy
TA1 = [ NaN, 1, NaN, NaN, NaN, NaN, 0.9958, NaN, NaN, NaN, NaN, 0.9232, NaN, NaN, NaN, NaN, 0.8231, NaN; %Dietz 1997
        NaN, 1, NaN, NaN, NaN, NaN, 0.9768, NaN, NaN, NaN, NaN, 0.9081, NaN, NaN, NaN, NaN, 0.7944, NaN; %Dietz 1998
        NaN, 1, NaN, NaN, NaN, NaN, 0.9949, NaN, NaN, NaN, NaN, 0.9608, NaN, NaN, NaN, NaN, 1.0383, NaN; %Ferris 2001
        NaN, 1, NaN, NaN, NaN, NaN, NaN, NaN, 1.0122, NaN, NaN, 0.9755, NaN, NaN, NaN, NaN, 1.0972, NaN]; %Ivanenko 2002

TA1L = TA1(:,2:17);
bws1 = repmat(bws(2:17),4,1);
TA1_lm = fitlm(bws1(:),TA1L(:));

TA1 = [fillmissing(TA1(1,:),'linear','Endvalues','none');
       fillmissing(TA1(2,:),'linear','Endvalues','none');
       fillmissing(TA1(3,:),'linear','Endvalues','none')
       fillmissing(TA1(4,:),'linear','Endvalues','none')];     

% Overground - healthy
TA2 = [  NaN, 1, NaN, NaN, 0.8114,  NaN,   NaN,  0.5788,  NaN,  NaN, NaN,  NaN,  NaN, NaN,  NaN,  NaN,  NaN,  NaN; % Fischer 2015 - TA
         NaN, 1, NaN, 0.9487, NaN,0.7949,   NaN,  0.7308,  NaN,  0.7564, NaN,  NaN,  NaN, NaN,  NaN,  NaN,  NaN,  NaN]; %Mun 2016 -  TA

TA2L = TA2(:,2:10);
bws2 = repmat(bws(2:10),2,1);
TA2_lm = fitlm(bws2(:),TA2L(:));

TA2 = [fillmissing(TA2(1,:),'linear','Endvalues','none');
       fillmissing(TA2(2,:),'linear','Endvalues','none')];

TA3 = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
TA4 = [NaN, 1, NaN, NaN, NaN, NaN, 0.9632, NaN, NaN, NaN, NaN, 0.8058, NaN, NaN, NaN, NaN, 0.7912, NaN; %Dietz 1997
        NaN, 1, NaN, NaN, NaN, NaN, 0.9539, NaN, NaN, NaN, NaN, 0.7784, NaN, NaN, NaN, NaN, 0.7764, NaN]; %Dietz 1998

TA4L = TA4(:,2:17);
bws4 = repmat(bws(2:17),2,1);
TA4_lm = fitlm(bws4(:),TA4L(:));

TA4 = [fillmissing(TA4(1,:),'linear','Endvalues','none');
       fillmissing(TA4(2,:),'linear','Endvalues','none')];


TA1M = mean(TA1,'omitnan');
TA1S = std(TA1,'omitnan');
TA2M = mean(TA2,'omitnan');
TA2S = std(TA2,'omitnan');
TA3S = [ 0, 0, 0, 0, 0,  0,   0,  0,  0,  0, 0,  0,  0, 0,  0,  0, 0, 0] ;
TA4M = mean(TA4,'omitnan');
TA4S = std(TA4,'omitnan');
TAM = [TA1M;TA2M;TA3;TA4M]';
TAS = [TA1S;TA2S;TA3S;TA4S]';

figure 
superbar(bws,TAM, 'E', TAS,'BarFaceColor', permute(Colour, [4 1 2 3]));
grid on
grid minor
axis([-10 80 0 1.5])
xticks([-10 0 10 20 30 40 50 60 70 80])
xticklabels({'No BWS', '0', '10', '20', '30', '40', '50', '60', '70', '80'})
set(gca,'fontsize',36)
ylabel('TA','FontSize',36,'FontWeight','bold')
xlabel('Percentage Body weight unloading (BWU)','FontSize',36,'FontWeight','bold')
hold on
TA1M_est = -9.2998e-4.*bws(2:17) + 1.0042;
plot(bws(2:17),TA1M_est,'r--','linewidth',2) 
TA2M_est = -0.0086.*bws(2:10) + 0.9839;
plot(bws(2:10),TA2M_est,'b--','linewidth',2) 
TA4M_est = -0.0033.*bws(2:17) + 1.0059;
plot(bws(2:17),TA4M_est,'m--','linewidth',2)    